
       /////////////////////////////////////////////////////
      //                                                 //
     //      Ambiente.java                              //
    //     por Marlon G. Chermont(chermont@lsi.usp.br) //
   //     Criado: 29/08/2001						  //
  //	 Ultima Alteracao: 05/11/2001                //
 //                                                 //
/////////////////////////////////////////////////////


import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.*;
import java.net.URL;

public class Ambiente implements AmbienteInterface
{
	//alguns parametros para a descricao do ambiente
	static final int NONE		 	= 0;	 //0000000000000
	static final int EXPOSE	 		= 1;     //0000000000001 (indica se o quarto deve ser exibido)
   	static final int WALL_UP   		= 1<<1;  //0000000000010
   	static final int WALL_LEFT 		= 1<<2;  //0000000000100
   	static final int WALL_DOWN 		= 1<<3;  //0000000001000
   	static final int WALL_RIGHT		= 1<<4;  //0000000010000
   	static final int ABISMO    		= 1<<5;  //0000000100000
   	static final int WUMPUS     	= 1<<6;  //0000001000000
   	static final int FLECHADA		= 1<<7;  //0000010000000 
   	static final int INICIO			= 1<<8;  //0000100000000
   	static final int PERIGO_ABISMO	= 1<<9;  //0001000000000
   	static final int PERIGO_WUMPUS	= 1<<10; //0010000000000
   	static final int GOLD         	= 1<<11; //0100000000000     

   	static int NUMX;	//descreve o tamanho do ambiente
   	static int NUMY;
	
	static int N_ABISMO;
   	static int N_WUMPUS;
   	static int N_WALLS;
   	static int N_GOLDS;
   	static int N_ARROWS;

    static int WORLD[][];

    Point MAN;
	Canvas pp;

    static final int UP    = 0;
    static final int LEFT  = 1;
    static final int DOWN  = 2;
    static final int RIGHT = 3;

    No inicio=null;
    No fim=null;
    
    int mundo[][];

	static boolean gameover;
	static int pontos;
	static int LPS; // armazena o valor limite de pontuao para o problema

	public Ambiente(int numx,int numy,int n_abismo,int n_wumpus,int n_paredes,int n_ouros, int n_flechas, Canvas pp)
	{
		NUMX=numx;
		NUMY=numy;
		gameover=false;
		pontos=0;
		this.pp=pp;  
		construindoMundo(n_abismo,n_wumpus,n_paredes,n_ouros,n_flechas);
	}
	
	//
	//
	// Este mtodo retorna as dimensoes do ambiente.
	//
	//
	public Point tamanhoAmb()
	{
		Point p =  new Point(NUMX,NUMY);
		return p;
	}
	
	//
    //
    //Este metodo ira gerar um ambiente randomicamente de acordo com os parametros 
    //especificados anteriormente.
    //
    //	Entrada: void.
    //	Saida: retorna uma matriz com o estado de cada sala do ambiente.
    //	Perigos: pode acontecer que o agente, Wumpus, Abismo ou uma pepita de ouro 
    //			 fiquem cercados por quatro paredes.
    //
    //
   	void inicializaMundo()
	{
			
		gameover = false;//indica que o jogo ainda nao acabou
		
		WORLD = new int[NUMY][NUMX];
		MAN = new Point();
		
		for(int i=0;i<NUMX;i++)
			for(int j=0;j<NUMY;j++)
				WORLD[j][i]=NONE;
				
	}	
	
	
	public void construindoMundo(int n_abismo,int n_wumpus,int n_paredes,int n_ouros, int n_flechas)
	{
		int i,x,y,direcao,gold;
		
		N_ABISMO = n_abismo;
		N_WUMPUS = n_wumpus;
   		N_WALLS  = n_paredes;
	   	N_GOLDS  = n_ouros;
   		N_ARROWS = n_flechas;
		
		inicializaMundo();
		
		WORLD[0][0]=EXPOSE|INICIO;
		MAN.move(0,0);//move o agente para a posicao de inicio		
		
		i=0;
		while(i<N_ABISMO)//insere N abismos no ambiente
		{
			x=randInt(NUMX);
			y=randInt(NUMY);
			if ((ABISMO!=(WORLD[y][x]&ABISMO))&&(INICIO!=(WORLD[y][x]&INICIO)))
			{
				WORLD[y][x]=ABISMO;
				i++;
			}
		}
		i=0;
		while(i<N_WUMPUS)//permite a insercao de mais de um WUMPUS no mesmo ambiente
		{				 
			x=randInt(NUMX);
			y=randInt(NUMY);
			if ((ABISMO!=(WORLD[y][x]&ABISMO))&&(WUMPUS!=(WORLD[y][x]&WUMPUS))
				&&(INICIO!=(WORLD[y][x]&INICIO)))
			{
				WORLD[y][x]=WUMPUS;
				i++;
			}
		}
		i=0;
		while (i<N_WALLS)//insere N paredes no ambiente, em direcoes e posicoes aleatorias
		{

			direcao=randInt(4);
			x=randInt(NUMX);
			y=randInt(NUMY);
			
			switch (direcao)
			{
			case UP:
				if (!verificaWallUp(x,y))
				{
					WORLD[y][x]|=WALL_UP;
					WORLD[(y+NUMY-1)%NUMY][x]|=WALL_DOWN;
					i++;
				}
				break;
			case LEFT:
				if (!verificaWallLeft(x,y))
				{
					WORLD[y][x]|=WALL_LEFT;
					WORLD[y][(x+NUMX-1)%NUMX]|=WALL_RIGHT;
					i++;
				}
				break;
			case DOWN:
				if (!verificaWallDown(x,y))
				{
					WORLD[y][x]|=WALL_DOWN;
					WORLD[(y+NUMY+1)%NUMY][x]|=WALL_UP;
					i++;
				}
				break;
			case RIGHT:
				if (!verificaWallRight(x,y))
				{
					WORLD[y][x]|=WALL_RIGHT;
					WORLD[y][(x+NUMX+1)%NUMX]|=WALL_LEFT;
					i++;
				}
				break;
			}
		}
		
		i=0;
		while (i<N_GOLDS)//insere N pepitas de ouro em posicoes aleatorias
		{
			x=randInt(NUMX);
			y=randInt(NUMY);
			gold=GOLD;
			
			if ((ABISMO!=(WORLD[y][x]&ABISMO))&&(WUMPUS!=(WORLD[y][x]&WUMPUS)))
			{
				while(gold==(WORLD[y][x]&gold))//permite inserir mais de uma pepita 
					gold=gold<<1;					  //de ouro no mesmo quadrante
				WORLD[y][x]|=gold;
				i++;
			}
		}
	}
	
	//
	//
	//Este metodo recebe um ponto do ambiente e verifica se
	//eh possivel sentir a presenca do wumpus
	//
	//	Entrada: coordenadas de um ponto (x,y)
	//	Saida:	confirmacao se existe algum Wumpus por perto
	//	Perigo: nenhum
	//
	//
	public boolean buscaPercepcaoWumpus(int x, int y)
	{

	
		if(!verificaWallUp(x,y)) //indica que nao existe parede na parte superior da sala, portanto e possivel sentir algo que venha de cima
	   		if(WUMPUS == (WORLD[(y+NUMY-1)%NUMY][x] & WUMPUS)||(FLECHADA == (WORLD[(y+NUMY-1)%NUMY][x] & FLECHADA)))
				return true;	
		if(!verificaWallLeft(x,y)) //indica que nao existe parede a esquerda da sala, portanto e possivel sentir algo que venha de la
			if(WUMPUS == (WORLD[y][(x+NUMX-1)%NUMX] & WUMPUS)||(FLECHADA == (WORLD[y][(x+NUMX-1)%NUMX] & FLECHADA)))
				return true;	 	 	
		if(!verificaWallDown(x,y)) //indica que nao existe parede na parte inferior da sala, portanto e possivel sentir algo que venha de la
			if(WUMPUS == (WORLD[(y+NUMY+1)%NUMY][x] & WUMPUS)||(FLECHADA == (WORLD[(y+NUMY+1)%NUMY][x] & FLECHADA)))
				return true;	
		if(!verificaWallRight(x,y)) //indica que nao existe parede a direita da sala, portanto e possivel sentir algo que venha de la
		 	if(WUMPUS == (WORLD[y][(x+NUMX+1)%NUMX] & WUMPUS)||(FLECHADA == (WORLD[y][(x+NUMX+1)%NUMX] & FLECHADA)))
	   			return true;	
		return false;
	}
	
 	
	//
	//
	//Este metodo recebe um ponto do ambiente e verifica se
	//eh possivel sentir a presenca de um abismo
	//
	//	Entrada: coordenadas de um ponto (x,y)
	//	Saida:	confirmacao se existe algum abismo por perto
	//	Perigo: nenhum
	//
	//
	public boolean buscaPercepcaoPit(int x, int y)
	{
		int status = WORLD[y][x];//passa o estado da posicao (x,y) do ambiente
	
		if(!verificaWallUp(x,y)) //indica que nao existe parede na parte superior da sala, portanto e possivel sentir algo que venha de cima
		   	if(ABISMO==(WORLD[(y+NUMY-1)%NUMY][x]&ABISMO))
				return true;	
		if(!verificaWallLeft(x,y)) //indica que nao existe parede a esquerda da sala, portanto e possivel sentir algo que venha de la
			if(ABISMO==(WORLD[y][(x+NUMX-1)%NUMX]&ABISMO))
		   	   	return true;	 	 	
		if(!verificaWallDown(x,y)) //indica que nao existe parede na parte inferior da sala, portanto e possivel sentir algo que venha de la
	 	   	if(ABISMO==(WORLD[(y+NUMY+1)%NUMY][x]&ABISMO))
		   		return true;	
		if(!verificaWallRight(x,y)) //indica que nao existe parede a direita da sala, portanto e possivel sentir algo que venha de la
	   		if(ABISMO==(WORLD[y][(x+NUMX+1)%NUMX]&ABISMO))
	   			return true;	
		return false;
	}
		
	//
	//Esta metodo gera um numero inteiro aleatorio
	//
	//	Entrada: o valor limite
	//	Saida:   um numero inteiro maior ou igual a zero e menor que o valor limite
	//	Perigo:  nenhum
	//
	int randInt(int limit)
	{
      return (int)(Math.random()*limit);
	}
	
	public boolean verificaWallUp(int x, int y)//metodo utilizado pelo ambiente para fazer a sua analise
	{
		if(WALL_UP!=(WORLD[y][x]&WALL_UP))
			return false;
		else
			return true;
	}
	public boolean verificaWallLeft(int x, int y)
	{
		if(WALL_LEFT!=(WORLD[y][x]&WALL_LEFT))
			return false;
		else
			return true;
	}	
	public boolean verificaWallDown(int x, int y)
	{
		if(WALL_DOWN!=(WORLD[y][x]&WALL_DOWN))
			return false;
		else
			return true;
	}		
	public boolean verificaWallRight(int x, int y)
	{
		if(WALL_RIGHT!=(WORLD[y][x]&WALL_RIGHT))
			return false;
		else
			return true;
	}	
	
	
	//
	//
	//Este metodo recebe uma posicao (x,y) na qual foi disparada uma flecha
	//e verifica se ela acertou o Wumpus, atualizando o estado da sala
	//
	//	Entrada: coordenadas da posio da flecha
	//	Saida:   Nada. Simplesmente atualiza o status da sala
	//	Perigo:  Nenhum
	//
	//	
	public void morteWumpus(int x, int y)
	{
		if (WUMPUS==(WORLD[y][x]&WUMPUS))
		{
			WORLD[y][x] &= (~WUMPUS);//afirma que o wumpus morreu
			WORLD[y][x] |= FLECHADA; //indica que nesta sala existe um Wumpus morto
			pontos+=10000;
			pp.repaint();
		}
	}
	
	public boolean verificaOuro(int x,int y)
	{
		if ((WORLD[y][x]&GOLD)==GOLD)
			return true;
		else 
			return false;
	}
	
	
	//
	//
	//Este metodo verifica se existe alguma pepita e executa a acao de pega-la
	//
	//	Entrada: a posicao do agente
	//	Saida:	 atualiza a pontuacao de acordo com a movimentacao e se pegou alguma pepita
	//			 adiciona 1000 a sua pontuacao
	//	Perigo:	 nenhum
	//
	//
	public void pegaPepita()
	{
		pontos--;
		if (verificaOuro(MAN.x,MAN.y))
		{
			pontos+=1000;
			for(int i=GOLD,j=GOLD<<1;(i&WORLD[MAN.y][MAN.x])>0;i=i<<1,j=j<<1)
				if ((j&WORLD[MAN.y][MAN.x])==0)//verifica se existe mais de uma pepita de ouro
					WORLD[MAN.y][MAN.x]&=(~i);//atualiza o status da sala com menos uma pepita
			pp.repaint();
		}	
	}
	
	//		
	//
	//Este metodo eh responsavel por movimentar o agente, atualizando a sua posicao.
	//Tambem eh reponsavel por indicar a direcao de lancamento da flecha
	//	
	//	Entrada: recebe a direcao do movimento
	//	Saida:	 atualiza as posicoes
	//	Perigo:  nenhum
	//
	//
	public void move(int d) 
	{
   		boolean moveOK=false;
		
		pontos--;	//reduz um ponto por movimentacao
		if (!gameover)
		{
			switch (d) 
			{
				case UP :
					if (!verificaWallUp(MAN.x,MAN.y))
					{
						MAN.y = (MAN.y+NUMY-1)%NUMY;
						moveOK=true;	//afirma que a movimentacao foi bem sucedida
					}
					break;
				case DOWN :
					if (!verificaWallDown(MAN.x,MAN.y))
					{
						MAN.y = (MAN.y+1)%NUMY;
						moveOK=true;
					}
				    break;
				case LEFT :
					if (!verificaWallLeft(MAN.x,MAN.y))
					{
						MAN.x = (MAN.x+NUMX-1)%NUMX;
						moveOK=true;
					}
					break;
				case RIGHT :
					if (!verificaWallRight(MAN.x,MAN.y))
					{
						MAN.x = (MAN.x+1)%NUMX;
						moveOK=true;
					}	
					break;
			}
			verificaGameOver();//verifica se esta movimentacao ocasionou GameOver
			if (moveOK)
				WORLD[MAN.y][MAN.x] |= EXPOSE; //indica que o novo quarto explorado pode ser pintado na tela
			pp.repaint();
		}
	}
	
	//
	//Este metodo diz para ocultar o quarto exibido
	//
	public void ocultar(Point p)
	{
		WORLD[p.y][p.x]&=(~EXPOSE);
	}
	//
	//Este metodo diz para exibir o quarto 
	//
	public void exibir(Point p)
	{
		WORLD[p.y][p.x]|=EXPOSE;
	}	
	
	
	//
	//Este metodo verifica se eh possivel sair da caverna e se for encerra o jogo
	//
	public void voltaPraCasa()
	{
		pontos--;
		if ((WORLD[MAN.y][MAN.x]&INICIO)==INICIO)
		{
			pontos+=1000;	//ganha 1000 pontos por conseguir sair vivo da caverna
			gameOver();
		}
		return;
	
	}
		
	
	//
	//Este metodo atualiza as informacoes do ambiente de acordo com o estado de GameOver
	//
	void gameOver()
	{
		gameover=true;
		for(int i=0;i<NUMX;i++)
			for(int j=0;j<NUMY;j++)
				WORLD[j][i]|=EXPOSE;
		pp.repaint();	
	}  
	//
	//Este metodo verifica se o agente caiu no abismo ou foi devorado pelo wumpus
	//
	public void verificaGameOver()
	{
		if ((WORLD[MAN.y][MAN.x]&WUMPUS)==WUMPUS)	//verifica se o agente entrou na sala do wumpus 
		{
			pontos-=10000;	//o agente perde 10000 pontos
			gameOver();
		}
		else if((WORLD[MAN.y][MAN.x]&ABISMO)==ABISMO)	//verifica se o agente caiu no abismo
		{
			pontos-=10000;	//o agente perde 10000 pontos
			gameOver();
		}
	}
	
	public boolean verificaGameover()
	{
		return gameover;
	}
	
	public int pegaPontuacao()
	{
		return pontos;
	}
	public void decrementaPontuacao()
	{
		pontos--;
	}
	
	
	public boolean	verificaFlecha()
	{
		if(N_ARROWS>0)//verifica se existe flecha na aljava
			return true;
		else
			return false;
	}
	public void atiraFlecha()
	{
		N_ARROWS--;//retira uma flecha da aljava
		pp.repaint();
	}
	
	
	//
	//metodos auxiliares para a pintura do ambiente
	//
	
	public boolean verificaPerigoWumpus(int x,int y)
	{
		if((WORLD[y][x]&PERIGO_WUMPUS)==PERIGO_WUMPUS)
			return true;
		return false;
	}
	public void setPerigoWumpus(int x,int y)
	{
		WORLD[y][x]|=PERIGO_WUMPUS;
	}
	public void setPerigoAbismo(int x,int y)
	{
		WORLD[y][x]|=PERIGO_ABISMO;
	}	
	
	public boolean verificaPerigoAbismo(int x, int y)
	{
		if((WORLD[y][x]&PERIGO_ABISMO)==PERIGO_ABISMO)
			return true;
		return false;
	}
	public boolean verificaFlechada(int x, int y)
	{
		if ((WORLD[y][x]&FLECHADA)==FLECHADA)
			return true;
		return false;
	}
	public boolean verificaInicio(int x, int y)
	{
		if ((WORLD[y][x]&INICIO)==INICIO)
			return true;
		return false;
	}
	public boolean verificaAbismo(int x, int y)
	{
		if((WORLD[y][x]&ABISMO)==ABISMO)
			return true;
		return false;
	}
	public boolean verificaWumpus(int x, int y)
	{
		if((WORLD[y][x]&WUMPUS)==WUMPUS)
			return true;
		return false;
	}
	public boolean verificaExpose(int x, int y)
	{
		if((WORLD[y][x]&EXPOSE)==EXPOSE)
			return true;
		return false;
	}	
	
	public Point pegaPosicao()
	{
		return MAN;
	}
	
	public int pegaNumFlechas()
	{
		return N_ARROWS;
	}
	
	//
	//
	//	Metodos para busca do melhor caminho
	//
	//
	void zeramundo()
	{
		for(int i=0;i<NUMX;i++)
			for(int j=0;j<NUMY;j++)
				mundo[i][j]&=(~EXPOSE);  //diz que o mundo ainda nao foi explorado
	}
	void copiamundo()
	{
		for(int i=0;i<NUMX;i++)
			for(int j=0;j<NUMY;j++)
				mundo[i][j]=WORLD[i][j];
	}
	public void pegaOuro(No no)
	{
		Point p = no.posicao;
		if (verificaOuro(p.x,p.y))
		{
			for(int i=GOLD,j=GOLD<<1;(i&mundo[p.y][p.x])>0;i=i<<1,j=j<<1)
				if ((j&mundo[p.y][p.x])==0)//verifica se existe mais de uma pepita de ouro
					mundo[p.y][p.x]&=(~i);//atualiza o status da sala com menos uma pepita
		}	
	}
	public void mataWumpus(No no)
	{
		Point p = no.posicao;
			mundo[p.y][p.x]&=(~WUMPUS);
	}
	private boolean verfOuro(No no)
	{
		Point p = no.posicao;
		if ((mundo[p.y][p.x]&GOLD)==GOLD)
			return true;
		else
			return false;	
	}
	public int calculaLimiteSuperior()
	{
		boolean fimdabusca = false;
		Point man = new Point(0,0);

		LPS = 0;
		mundo = new int[NUMX][NUMY];
		copiamundo();
		
		while (!fimdabusca)
		{
			inicio = null;
			fim = null;
			System.out.println("fim da busca"+fimdabusca);
			zeramundo();
			No no = busca(GOLD,man);
			if (no!=null)
			{
				if(verfOuro(no))
				{
					LPS+=999;
					man=no.posicao;
					pegaOuro(no);
				}
				else
				{
					LPS+=10000;
					man=no.pai.posicao;
					mataWumpus(no);
				}
				
				while (no!=null)
				{
					switch (no.direcao)
					{
						case 0:
							System.out.println("CIMA");
							LPS--;
							break;
						case 1:
							System.out.println("ESQUERDA");
							LPS--;
							break;
						case 2:
							System.out.println("BAIXO");
							LPS--;
							break;
						case 3:
							System.out.println("DIREITA");
							LPS--;
							break;
					}			
					no=no.pai;
				}		
			}
			else
			{
			
				zeramundo();
				no = busca(INICIO,man);
				while (no!=null)
				{
					switch (no.direcao)
					{
						case 0:
							System.out.println("CIMA");
							LPS--;
							break;
						case 1:
							System.out.println("ESQUERDA");
							LPS--;
							break;
						case 2:
							System.out.println("BAIXO");
							LPS--;
							break;
						case 3:
							System.out.println("DIREITA");
							LPS--;
							break;
					}			
					no=no.pai;
				}
				fimdabusca=true;
				LPS+=999;	//1000 pontos por sair da caverna
			}	
		}
		return LPS;		
	}
	public No busca(int objetivo, Point localizacao)
	{
		No no;
		if (inicio==null)
		{
			no = new No();
			no.posicao=localizacao;
			no.direcao=5;		//indica que e a posicao de inicio da buscaOuro
			no.prox=null;
			inicio= fim= no;
			if ( verificaObjetivo(no,objetivo))
					return no;
		}
		else
		{
			no = new No();
			if (verificaSePodeUp(inicio))
			{
				no = new No();
				Point p = inicio.posicao;
				no.posicao=new Point(p.x,(p.y-1+NUMY)%NUMY);
				fim.prox=no;
				fim=no;
				no.pai=inicio;
				no.direcao=UP;
				no.prox=null;
				mundo[p.x][p.y]|=EXPOSE;
				if ( verificaObjetivo(no,objetivo))
					return no;
			}
			if (verificaSePodeLeft(inicio))
			{
				no = new No();
				Point p = inicio.posicao;
				no.posicao=new Point((p.x+NUMX-1)%NUMX,p.y);
				fim.prox=no;
				fim=no;
				no.pai=inicio;
				no.direcao=LEFT;
				no.prox=null;
				mundo[p.x][p.y]|=EXPOSE;
				if ( verificaObjetivo(no,objetivo))
					return no;
			}			
			if (verificaSePodeDown(inicio))
			{
				no = new No();
				Point p = inicio.posicao;
				no.posicao=new Point(p.x,(p.y+1+NUMY)%NUMY);
				fim.prox=no;
				fim=no;
				no.pai=inicio;
				no.direcao=DOWN;
				no.prox=null;
				mundo[p.x][p.y]|=EXPOSE;
				if ( verificaObjetivo(no,objetivo))
					return no;
			}			
			if (verificaSePodeRight(inicio))
			{
				no = new No();
				Point p = inicio.posicao;
				no.posicao=new Point((p.x+NUMX+1)%NUMX,p.y);
				fim.prox=no;
				fim=no;
				no.pai=inicio;
				no.direcao=RIGHT;
				no.prox=null;
				mundo[p.x][p.y]|=EXPOSE;
				if ( verificaObjetivo(no,objetivo))
					return no;
			}
			inicio= inicio.prox;
			if(inicio==null)
				return null;
		}
		no = busca(objetivo,localizacao);
			
		return no;
	}
	
	boolean verificaSePodeUp(No no)
	{
		Point p = no.posicao;
		if (verificaWallUp(p.x,p.y))
			return false;
		else
		{	
			if(verificaAbismo(p.x,(p.y-1+NUMY)%NUMY))
				return false;
			else 
				if((mundo[p.x][(p.y-1+NUMY)%NUMY]&EXPOSE)==EXPOSE)
					return false;
				else
					return true;
		}
	}
	boolean verificaSePodeLeft(No no)
	{
		Point p = no.posicao;
		if (verificaWallLeft(p.x,p.y))
			return false;
		else
		{	
			if(verificaAbismo((p.x+NUMX-1)%NUMX,p.y))
				return false;
			else 
				if((mundo[(p.x+NUMX-1)%NUMX][p.y]&EXPOSE)==EXPOSE)
					return false;
				else
					return true;
		}
	}
	boolean verificaSePodeDown(No no)
	{
		Point p = no.posicao;
		if (verificaWallDown(p.x,p.y))
			return false;
		else
		{	
			if(verificaAbismo(p.x,(p.y+1+NUMY)%NUMY))
				return false;
			else 
				if((mundo[p.x][(p.y+1+NUMY)%NUMY]&EXPOSE)==EXPOSE)
					return false;
				else	
					return true;
		}
	}
	boolean verificaSePodeRight(No no)
	{
		Point p = no.posicao;
		if (verificaWallRight(p.x,p.y))
			return false;
		else
		{	
			if(verificaAbismo((p.x+NUMX+1)%NUMX,p.y))
				return false;
			else 
				if((mundo[(p.x+NUMX+1)%NUMX][p.y]&EXPOSE)==EXPOSE)
					return false;
				else	
					return true;
		}
	}
	
	boolean verificaObjetivo(No no, int objetivo)
	{
		Point p = no.posicao;
		if((mundo[p.y][p.x]&objetivo)==objetivo)
			return true;
		else 
			return false;
	}
	boolean verificaInicio(No no)
	{
		Point p = no.posicao;
		return verificaInicio(p.x,p.y);
	}

	//
	//
	//
	//Metodos de Percepcao do agente
	//
	//
	//
	public boolean verificaInicio()
	{
		if ((WORLD[MAN.y][MAN.x]&INICIO)==INICIO)
			return true;
		return false;
	}
		public boolean verificaWallUp()//metodo utilizado pelo agente para pegar percepcao
	{
		if(WALL_UP!=(WORLD[MAN.y][MAN.x]&WALL_UP))
			return false;
		else
			return true;
	}	
	public boolean verificaWallLeft()
	{
		if(WALL_LEFT!=(WORLD[MAN.y][MAN.x]&WALL_LEFT))
			return false;
		else
			return true;
	}	
	public boolean verificaWallDown()
	{
		if(WALL_DOWN!=(WORLD[MAN.y][MAN.x]&WALL_DOWN))
			return false;
		else
			return true;
	}
	public boolean verificaWallRight()
	{
		if(WALL_RIGHT!=(WORLD[MAN.y][MAN.x]&WALL_RIGHT))
			return false;
		else
			return true;
	}	
	public boolean verificaOuro()
	{
		if ((WORLD[MAN.y][MAN.x]&GOLD)==GOLD)
			return true;
		else 
			return false;
	}
	//
	//
	//Este metodo verifica se
	//eh possivel sentir a presenca de um abismo
	//
	//	Entrada: nenhuma
	//	Saida:	confirmacao se existe algum abismo por perto
	//	Perigo: nenhum
	//
	//
	public boolean verificaAbismo()
	{
		int status = WORLD[MAN.y][MAN.x];//passa o estado da posicao (x,y) do ambiente
	
		if(!verificaWallUp(MAN.x,MAN.y)) //indica que nao existe parede na parte superior da sala, portanto e possivel sentir algo que venha de cima
		   	if(ABISMO==(WORLD[(MAN.y+NUMY-1)%NUMY][MAN.x]&ABISMO))
				return true;	
		if(!verificaWallLeft(MAN.x,MAN.y)) //indica que nao existe parede a esquerda da sala, portanto e possivel sentir algo que venha de la
			if(ABISMO==(WORLD[MAN.y][(MAN.x+NUMX-1)%NUMX]&ABISMO))
		   	   	return true;	 	 	
		if(!verificaWallDown(MAN.x,MAN.y)) //indica que nao existe parede na parte inferior da sala, portanto e possivel sentir algo que venha de la
	 	   	if(ABISMO==(WORLD[(MAN.y+NUMY+1)%NUMY][MAN.x]&ABISMO))
		   		return true;	
		if(!verificaWallRight(MAN.x,MAN.y)) //indica que nao existe parede a direita da sala, portanto e possivel sentir algo que venha de la
	   		if(ABISMO==(WORLD[MAN.y][(MAN.x+NUMX+1)%NUMX]&ABISMO))
	   			return true;	
		return false;
	}
	//
	//
	//Este metodo verifica se
	//eh possivel sentir a presenca do wumpus
	//
	//	Entrada: nenhuma
	//	Saida:	confirmacao se existe algum Wumpus por perto
	//	Perigo: nenhum
	//
	//
	public boolean verificaWumpus()
	{

	
		if(!verificaWallUp()) //indica que nao existe parede na parte superior da sala, portanto e possivel sentir algo que venha de cima
	   		if(WUMPUS == (WORLD[(MAN.y+NUMY-1)%NUMY][MAN.x] & WUMPUS))
				return true;	
		if(!verificaWallLeft()) //indica que nao existe parede a esquerda da sala, portanto e possivel sentir algo que venha de la
			if(WUMPUS == (WORLD[MAN.y][(MAN.x+NUMX-1)%NUMX] & WUMPUS))
				return true;	 	 	
		if(!verificaWallDown()) //indica que nao existe parede na parte inferior da sala, portanto e possivel sentir algo que venha de la
			if(WUMPUS == (WORLD[(MAN.y+NUMY+1)%NUMY][MAN.x] & WUMPUS))
				return true;	
		if(!verificaWallRight()) //indica que nao existe parede a direita da sala, portanto e possivel sentir algo que venha de la
		 	if(WUMPUS == (WORLD[MAN.y][(MAN.x+NUMX+1)%NUMX] & WUMPUS))
	   			return true;	
		return false;
	}

}