
      /////////////////////////////////////////////////////
     //                                                 //
    //      AgenteBase.java                            //
   //     por Marlon G. Chermont(chermont@lsi.usp.br) //
  //    Ultima Alteracao: 08/10/2001  18/04/2002     //
 //                                                 //
/////////////////////////////////////////////////////

//Este Agente serve como base de comunicacao com o ambiente
//Aqui descrevemos todas as operacoes que podem ser realizadas com o agente
//Algumas dessas operaes so simpesmentes utilizadas para controle em 
//alguns tipos de agentes descendentes do agenteBase

package agentes;
import AmbienteInterface;
import No;
import java.awt.*;

public class AgenteBase
{
	private AmbienteInterface amb;	//interfacede comunicao com o ambiente
	
	boolean firemode;	//indica o estado do agente
	int firedir;		//indica uma direcao de disparo para flecha
	
	public static final int UP    = 0;	//definimos as direes
    public static final int LEFT  = 1;
    public static final int DOWN  = 2;
    public static final int RIGHT = 3;
	
	//construtor do agenteBase
	public AgenteBase()
	{
		firemode=false;	//inicia fora do estado de ataque
		firedir=5;	//este 5 indica que nao existe nenhuma direcao
	}
	//recebe o ambiente para comunicao
	public void setAmbiente(AmbienteInterface Amb)
	{
		amb=Amb;
	}
	//retorna o ambiente de comunicao
	public AmbienteInterface returnAmbiente()
	{
		return amb;
	}
	//retorna as dimenses do ambiente utilizado
	public Point dimensaoAmb()
	{
		Point p =  amb.tamanhoAmb();
		return p;
	}
	//metodo utilizados por alguns agentes descendentes para inicializar
	//a copia que ira ser criada do ambiente
	public void inicializaMundo()
	{
	}
	//pedido de acoes a ser executada pelo agente autonomo
	public void action()
	{
	}
	//Acoes possiveis de ser realizadas
	protected void move(int d)
	{
		amb.move(d);	//chama esta mesma acao no ambiente
	}
	protected void pegaPepita()
	{
		amb.pegaPepita();
	}
	protected void voltaPraCasa()
	{
		amb.voltaPraCasa();
	}
	public void setFireDir(int d)
	{
		firedir=d;
		amb.atiraFlecha();
	}
	public int pegaFireDir()
	{
		return firedir;
	}
	public boolean verificaFireMode()
	{
		return firemode;
	}
	public void setFireMode()
	{
		firemode=!firemode;
	}
	public boolean verificaWallUp(int x,int y)
	{
		return amb.verificaWallUp(x,y);
	}
	public boolean verificaWallDown(int x,int y)
	{
		return amb.verificaWallDown(x,y);
	}
	public boolean verificaWallLeft(int x,int y)
	{
		return amb.verificaWallLeft(x,y);
	}
	public boolean verificaWallRight(int x,int y)
	{
		return amb.verificaWallRight(x,y);
	}
	public boolean verificaOuro()
	{
		return amb.verificaOuro();
	}
	public boolean verificaWumpus()
	{
		return amb.verificaWumpus();
	}
	public boolean verificaFlecha()
	{
		return amb.verificaFlecha();
	}
	public boolean verificaAbismo()
	{
		return amb.verificaAbismo();
	}
	public boolean verificaInicio()
	{
		return amb.verificaInicio();
	}
	//indica que uma casa do ambiente pode ser exibida
	public void exibir(Point p)
	{
		amb.exibir(p);
	}
	public void ocultar(Point p)
	{
		amb.ocultar(p);
	}
	public Point pegaPosicao()
	{
		return amb.pegaPosicao();
	}

}
