      /////////////////////////////////////////////////////
      //                                                 //
     //      AgenteMapeadorArray.java                         //
    //     por Marlon G. Chermont(chermont@lsi.usp.br) //
   //     Criado: 07/03/2002						  //
  //	Ultima Alteracao: 18/04/2002                 //
 //                                                 //
/////////////////////////////////////////////////////

package agentes;
import java.awt.*;

public class AgenteMapeadorArray extends AgenteBase
{
	static final int PEGAROURO      = 1;
	static final int MOVER          = 1<<1;
	static final int ATIRARFLECHA   = 1<<2;
	static final int VOLTAR	    	= 1<<3;
	static final int SAIR			= 1<<4;
	
	
	//alguns parametros para a descricao do ambiente
	static final int NONE		 	= 0;	 //0000000000000
	static final int EXPOSE	 		= 1;     //0000000000001 (indica se o quarto deve ser exibido)
   	static final int WALL_UP   		= 1<<1;  //0000000000010
   	static final int WALL_LEFT 		= 1<<2;  //0000000000100
   	static final int WALL_DOWN 		= 1<<3;  //0000000001000
   	static final int WALL_RIGHT		= 1<<4;  //0000000010000
   	static final int ABISMO    		= 1<<5;  //0000000100000
   	static final int WUMPUS     	= 1<<6;  //0000001000000
   	static final int WUMPUS_MORTO	= 1<<7;  //0000010000000 
   	static final int INICIO			= 1<<8;  //0000100000000
   	static final int PERIGO_ABISMO	= 1<<9;  //0001000000000
   	static final int PERIGO_WUMPUS	= 1<<10; //0010000000000
   	static final int GOLD         	= 1<<11; //0100000000000

	//memoria primitiva
	static int ultimaDir;
	static boolean pegouOuro=false;
	static boolean atirouFlecha=false;
	
	static int DIR;
	static int NUMX,NUMY;
	
	static Point dimAmb;
	static int meuMundo[][];
	
	Point man = new Point(0,0); //posicao do agente
	
	
	
	public AgenteMapeadorArray()
	{
		super();
		ultimaDir=5;
		pegouOuro=false;
		//inicializaMundo();
		
	}
	
	public void inicializaMundo()
	{
		dimAmb = dimensaoAmb();	
		NUMX = (int) dimAmb.getX();
		NUMY = (int) dimAmb.getY();
		
		meuMundo = new int[NUMX][NUMY];
		for(int i=0;i<NUMX;i++)
			for(int j=0;j<NUMY;j++)
				meuMundo[j][i]=NONE;
	}
	
	void pegaPercepcao()
	{
		if(EXPOSE != (meuMundo[man.y][man.x] & EXPOSE))
			meuMundo[man.y][man.x]+=EXPOSE;
		
		if(verificaWallUp(man.y,man.x))
			meuMundo[man.y][man.x]+=WALL_UP;
		if(verificaWallDown(man.y,man.x))
			meuMundo[man.y][man.x]+=WALL_DOWN;
		if(verificaWallLeft(man.y,man.x))
			meuMundo[man.y][man.x]+=WALL_LEFT;
		if(verificaWallRight(man.y,man.x))
			meuMundo[man.y][man.x]+=WALL_RIGHT;
		if(verificaWumpus())
			meuMundo[man.y][man.x]+=PERIGO_WUMPUS;
		if(verificaAbismo())
			meuMundo[man.y][man.x]+=PERIGO_ABISMO;
		if(verificaInicio())
			meuMundo[man.y][man.x]+=INICIO;
	}
	
	
	public void action()
	{
		pegaPercepcao();
		if (verificaFireMode())
			setFireMode();
		else if (verificaOuro())
		{
			pegaPepita();
			System.out.println("PEGAROURO");
			pegouOuro=true;
		}
		else if(verificaInicio() && pegouOuro)
		{	
			voltaPraCasa();
			System.out.println("SAIR");
		}
		else if(verificaWumpus())
		{
			if (verificaFlecha())	//verifica se o agente possui alguma flecha
			{
				DIR = (int)(Math.random()*4); //escolhe uma direcao aleatria
				setFireMode();
				setFireDir(DIR);
				System.out.println("ATIRARFLECHA"+DIR);
			}
			else
			{
				if (ultimaDir!=5) //verifica se ele ja fez alguma movimentacao 
				{
					ultimaDir = (ultimaDir+2)%4;//assume a direcao contraria
					move(ultimaDir);
					man=pegaPosicao();//pega a posicao atual do agente
					System.out.println("VOLTAR"+ultimaDir);
				}
				else
				{
					voltaPraCasa();
					System.out.println("SAIR");
				}
			}
		}
		else if(verificaAbismo())
		{
			if (ultimaDir!=5) //verifica se ele ja fez alguma movimentacao 
			{
				ultimaDir = (ultimaDir+2)%4;//assume a direcao contraria
				move(ultimaDir);
				man=pegaPosicao();//pega a posicao atual do agente
				System.out.println("VOLTAR"+ultimaDir);
			}
			else
			{
				voltaPraCasa();
				System.out.println("SAIR");
			}
		}
		else if (verificaDirecao(man.x,man.y,RIGHT))
		{	
			move(RIGHT);
			ultimaDir=RIGHT;
			man=pegaPosicao();//pega a posicao atual do agente
			System.out.println("MOVER PARA DIREITA");
		}
		else if (verificaDirecao(man.x,man.y,DOWN))
		{
			move(DOWN);
			ultimaDir=DOWN;
			man=pegaPosicao();//pega a posicao atual do agente
			System.out.println("MOVER PARA BAIXO");
		}
		else if (verificaDirecao(man.x,man.y,LEFT))
		{
			move(LEFT);
			ultimaDir=LEFT;
			man=pegaPosicao();//pega a posicao atual do agente
			System.out.println("MOVER PARA ESQUERDA");
		}
		else if (verificaDirecao(man.x,man.y,UP))
		{
			move(UP);
			ultimaDir=UP;
			man=pegaPosicao();//pega a posicao atual do agente
			System.out.println("MOVER PARA CIMA");
		}
		else
		{
		 	ultimaDir=(int)(Math.random()*4);
			move(ultimaDir);
			man=pegaPosicao();//pega a posicao atual do agente
			System.out.println("MOVE ALEATORIAMENTE");
		}
	}
	
	private boolean verificaDirecao(int x,int y, int dir)
	{
		switch (dir)
		{
			case UP :
				if (!verificaWallUp(x,y)) //indica que nao existe parede na parte superior da sala
		   			if(EXPOSE != (meuMundo[(y+NUMY-1)%NUMY][x] & EXPOSE))
						return true;
				else
					return false;	
				break;
			case LEFT:
				if(!verificaWallLeft(x,y)) //indica que nao existe parede a esquerda da sala
					if(EXPOSE != (meuMundo[y][(x+NUMX-1)%NUMX] & EXPOSE))
						return true;	 	 	
				break;
			case DOWN:
				if(!verificaWallDown(x,y)) //indica que nao existe parede na parte inferior da sala
					if(EXPOSE != (meuMundo[(y+NUMY+1)%NUMY][x] & EXPOSE))
						return true;	
				break;
			case RIGHT:
				if(!verificaWallRight(x,y)) //indica que nao existe parede a direita da sala
			 		if(EXPOSE != (meuMundo[y][(x+NUMX+1)%NUMX] & EXPOSE))
	   					return true;
				break;
			default:
				return false;
		
		}	
		return false;
	}
		
}